package org.greenstone3.ms;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SearchLink {

	//final String path = "/research/cc108/greenstone3/web/mat/";
	final String path = "/home/cc108/MRWks1/describeMessenger/";
	
	String collection ="";
	String metadataElement ="";
	//String core_element="";
	PrintWriter out;
	boolean status = true;
	
	public SearchLink(PrintWriter arg){
		out = arg;
	}
	
	public SearchLink(){
		
	}
	
	public boolean getStatus(){
		return status;
	}
	public static void main(String[] args){
		SearchLink sl = new SearchLink();	
		//sl.CreateIndentifierLinkPage("dc.Creator", "Lowe, David J.", "dc.Identifier","poilkjm");
		//sl.CreateIndentifierLinkPage("dc.Publisher2", "ResearchSpace@Auckland", "dc.Identifier1","vmeqlek");
	}
	
	public ArrayList CreateIndentifierLinkPage(String metadataElement, String text, String identifier, String col, HashMap valueMap, HashMap linkMap){
		collection = col;
		//System.out.println("valueMap: "+valueMap.size()+ " linkMap: "+ linkMap.size());
		this.metadataElement = metadataElement;
		//Element ex = openfile(metadataElement,col);
		try{
		if(valueMap.size()==0){
			status = false;
			return new ArrayList();
		}
		else{
			ArrayList alist = retrieveHASHID(valueMap,text);
			if(alist.size()==0){
				status = false;
				return new ArrayList();
			}
			//ex = openfile(identifier,col);
			if(linkMap.size()==0){
				//out.write("<p>"+ identifier +" does not exist </p>");
				status = false;
				return new ArrayList();
				//System.out.println(identifier + "does not exist2");
				//return createResult(new ArrayList());
			}
			else{
			ArrayList alist2 = retrieveHASHID(linkMap,alist,metadataElement);
			//System.out.println("break3");
			return alist2;
			}
		}
		}catch(Exception ex){ex.printStackTrace(); return new ArrayList();}
		//return "";
	}
	
	
	private Element openfile(String core_element, String collection){
		
		try{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
		    Document doc = docBuilder.newDocument();
		    //Element rootNode = doc.
		    //System.out.println(path+collection+"/metadataStats/"+core_element+".xml");
		    doc = docBuilder.parse (new File(path+"/"+collection+"/metadataStats/"+core_element+".xml"));
		    Element rootNode = doc.getDocumentElement();
		    return rootNode;  
		    }catch (Exception e) {
	    	    //e.printStackTrace();
		    	//out.write("<p>"+core_element +" does not exist </p>");
		    	System.out.println(core_element + " does not exist1");
		    	
	    	    return null;
		    }
	}
	
	private ArrayList retrieveHASHID (HashMap hp, String text){
		//ArrayList alist = new ArrayList();
	
     

	    if(hp.containsKey(text)){
	    	InternalLink il = (InternalLink) hp.get(text);
	    	return il.retrieveList();
	    }
	    else{
	    	return new ArrayList();
	    }
	}
	
	private ArrayList retrieveHASHID (HashMap hp, ArrayList arg,String metadataElement){
     //System.out.println(metadataElement);
		ArrayList alist = new ArrayList();
		for(int i = 0; i<arg.size(); i++){
			String text = (String)arg.get(i);
			if(hp.containsKey(text)){
				InternalLink il = (InternalLink) hp.get(text);
				ArrayList arrayList = il.retrieveList();
				if(arrayList.size()!=0){
					alist.add(il.retrieveList().get(0));
				}
				else{
					System.out.println(text);
					alist.add("&nbsp;");
				}
				//return il.retrieveList();
			}
			/*
			else{
				return new ArrayList();
			}
			*/
		}
		return alist;
	}
	/*
	private ArrayList retrieveHASHID (Element ex, ArrayList alist1){
		ArrayList alist = new ArrayList();

      	NodeList listOfFrequency = ex.getElementsByTagName("Document");
      	
      	if(listOfFrequency.getLength()==0){
      		//System.out.println("return 0");
      		return alist;
      	}
      	
      	for(int s=0; s<listOfFrequency.getLength() ; s++){
      	   Node docNode = listOfFrequency.item(s);
      	   NamedNodeMap NodeIDMap = docNode.getAttributes();
      	   Node DocNodeID = NodeIDMap.item(0);
      	   String DocID = DocNodeID.getNodeValue();

      	   if(alist1.contains(DocID)){
      		   //System.out.println("same");
      		   Element xNode = (Element)docNode;
          	   NodeList valueList = xNode.getElementsByTagName("ActualValue");
          	   
          	   
          	   for(int y = 0; y<valueList.getLength(); y++){
          		   Element valueElement = (Element)valueList.item(y);
          		   NodeList textFNList = valueElement.getChildNodes();
          		   String textValue = ((Node)textFNList.item(0)).getNodeValue();
          		   //System.out.println(textValue);
          		   if(textValue.startsWith("http://")){
          			   alist.add(textValue);
          			 break;
          		   }
       		    }
      	   }
        }
      	
		return alist;
	}
	*/
	/*
	private String createResult(ArrayList alist){
		//System.out.println("test");\
		String url = path+collection+"/"+metadataElement+"_result.html";
		//System.out.println(url);
		try{
	    	//FileWriter fstream = new FileWriter("/home/cc108/MRWks1/Quality"+"/"+collection+"/"+"hello"+"_result.html");
			//path /research/cc108/greenstone3/web/mat/
		
			//FileWriter fstream = new FileWriter(path+collection+"/"+metadataElement+"result.html");
			FileWriter fstream = new FileWriter(url);
		    BufferedWriter out = new BufferedWriter(fstream);
		    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r\n");
		    out.write("<html>\r\n");
		    out.write("<head>\r\n<title>Result</title>\r\n");
		    
		    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
		    out.write("</head>\r\n");
		    out.write("<body>\r\n");
		    out.write("<table border=\"1\" align=\"center\">\r\n");
		    out.write("<tr>");
	    	out.write("<td align=center> No.");
	    	out.write("<td align=center> URL");
		    //System.out.println(alist.size());
		    for(int i = 0; i < alist.size(); i++){
		    	out.write("<tr>");
		    	out.write("<td align>"+(i+1));
		    	out.write("<td align><a href=\""+(String)alist.get(i)+"\">"+(String)alist.get(i)+"</a>\n");
		    	
		    }
		    out.write("</table></body></html>\r\n");
		    out.close();
		    fstream.close();
		    //System.out.println("/home/cc108/MRWks1/Quality"+"/"+collection+"/"+metadataElement+"_result.html");
		}catch(Exception ex){
			//ex.printStackTrace();
			out.write("<p> links cannot be generated </p>");
		}
		return url;
	}
	*/
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public HashMap createValueMap(String core_element, String collection){
	//System.out.println("Create value map1 "+core_element);
 	HashMap hp = new HashMap();
 	Element ex = openfile(core_element,collection);
  	NodeList valueList = ex.getElementsByTagName("ActualValue");
  	
    for(int s=0; s<valueList.getLength() ; s++){
      	   Element docNode = (Element)valueList.item(s);
      	   NodeList NodeIDMap = docNode.getChildNodes();
      	   Node DocNodeID = NodeIDMap.item(0);
      	   String actualValue = DocNodeID.getNodeValue();
      	   String DocID = DocNodeID.getParentNode().getParentNode().getAttributes().item(0).getNodeValue();
  		 
      	   if(hp.containsKey(actualValue)){
      		 InternalLink il = (InternalLink) hp.get(actualValue);
      		 il.increaseElement(DocID);
      		 hp.put(actualValue, il);
      	   }
      	   else{
      		   InternalLink il = new InternalLink();
      		   il.setValue(actualValue);
      		   il.increaseElement(DocID);
      		   hp.put(actualValue, il);
      	   }
    	}
	System.out.println("Create value map2 "+core_element);
    return hp;
	}
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public HashMap createLinkMap (String core_element, String collection){
		//System.out.println("Create link map1 "+core_element);
		//ArrayList alist = new ArrayList();
		HashMap hp = new HashMap();
		Element ex = openfile(core_element,collection);
      	NodeList listOfFrequency = ex.getElementsByTagName("Document");
      	
      	if(listOfFrequency.getLength()==0){
      		return hp;
      	}
      	
      	for(int s=0; s<listOfFrequency.getLength() ; s++){
      	   Node docNode = listOfFrequency.item(s);
      	   NamedNodeMap NodeIDMap = docNode.getAttributes();
      	   Node DocNodeID = NodeIDMap.item(0);
      	   String DocID = DocNodeID.getNodeValue();


      	   if(hp.containsKey(DocID)){

      		   Element xNode = (Element)docNode;
          	   NodeList valueList = xNode.getElementsByTagName("ActualValue");
          	   
          	   ArrayList alist = new ArrayList();
          	   for(int y = 0; y<valueList.getLength(); y++){
          		   Element valueElement = (Element)valueList.item(y);
          		   NodeList textFNList = valueElement.getChildNodes();
          		   String textValue = ((Node)textFNList.item(0)).getNodeValue();

          		   if(textValue.startsWith("http://")){
          			 InternalLink il = (InternalLink)hp.get(DocID);
          			 //il.retrieveList();
          			   //alist.add(textValue);
          			 il.increaseElement(textValue);
          			 break;
          		   }
       		    }
      	   }
      	   
      	   
      	   else {
      		   InternalLink il = new InternalLink();
      		   il.setValue(DocID);
      		   
    		   Element xNode = (Element)docNode;
          	   NodeList valueList = xNode.getElementsByTagName("ActualValue");
          	   
          	   for(int y = 0; y<valueList.getLength(); y++){
          		   Element valueElement = (Element)valueList.item(y);
          		   NodeList textFNList = valueElement.getChildNodes();
          		   String textValue = ((Node)textFNList.item(0)).getNodeValue();

          		   if(textValue.startsWith("http://")){
          			   //alist.add(textValue);
          			 il.increaseElement(textValue);
          			 break;
          		   }
       		    }
          	   hp.put(DocID, il);
      	   }
        }
    	System.out.println("Create value map2 "+core_element);
		return hp;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
}
