package org.greenstone3.ms;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class collectionChooser extends JFrame {
	
    JPanel jPanel;
    JButton jButton1;
    JComboBox collectionComboBox;
    
    public collectionChooser() {
	
    	this.setTitle("Choose a collection");

    	DescribeMessager dm = new DescribeMessager();
        dm.describe();
        Node cList = dm.getCollectionList();
        Element collectionList = (Element) cList;
        NodeList collectionNameList = collectionList.getElementsByTagName("collection");
        String[] collectionStrings = new String[collectionNameList.getLength()];
        
        for(int i = 0; i< collectionNameList.getLength(); i++){
        	Node nameNode = collectionNameList.item(i);
        	collectionStrings[i] = nameNode.getAttributes().item(0).getNodeValue();
        }

      
        jButton1 = new JButton("Enter");
        jButton1.setPreferredSize(new Dimension(150,30));
        jButton1.setFont(new java.awt.Font("Times New Roman", Font.BOLD, 16));
        jButton1.addActionListener(new collectionChooser_jButton1_Adapter(this));
        
        collectionComboBox = new JComboBox(collectionStrings);
        collectionComboBox.setSelectedIndex(0);
        collectionComboBox.setPreferredSize(new Dimension(150,30));
        collectionComboBox.setFont(new java.awt.Font("Times New Roman", Font.BOLD, 16));
        
        JLabel text = new JLabel();
        text.setFont(new java.awt.Font("Times New Roman", Font.BOLD, 14));
        text.setText("Available Collection");
        text.setPreferredSize(new Dimension(150,30));
        
        //Lay out the demo.
        jPanel = new JPanel();
        jPanel.setLayout(new AbsoluteLayout());
        jPanel.add(text, new AbsoluteConstraints(30,20,170,30));
        jPanel.add(collectionComboBox, new AbsoluteConstraints(30,60,170,30));
        jPanel.add(jButton1, new AbsoluteConstraints(30,120,170,30));
        jPanel.setPreferredSize(new Dimension(225,180));
        this.setContentPane(jPanel);
        
        //Display the window.
        this.pack();
        this.setVisible(true);
    }
    
    
    /** Listens to the combo box. */
    public void jButton1_actionPerformed(ActionEvent e){ 
	String collectionName = collectionComboBox.getSelectedItem().toString();
	this.dispose();
	MainApplication ma = new MainApplication(collectionName);
    }
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    
    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
    	collectionChooser cc = new collectionChooser();    	
    }
}

class collectionChooser_jButton1_Adapter implements ActionListener {
    private collectionChooser adaptee;
    
    collectionChooser_jButton1_Adapter(collectionChooser adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
